#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>

#if defined(_WIN32)
#  include <windows.h>
#  include <direct.h>
#  include <io.h>
#  define mkdir(dirname, mode) _mkdir(dirname)
#  ifdef _MSC_VER
#    define strdup(str) _strdup(str)
#  endif
#endif
#if defined(vxWorks)
#  define mkdir(dirname, mode) mkdir(dirname)
#endif
/* recursive mkdir */
/* abort on ENOENT; ignore other errors like "directory already exists" */
/* return 1 if OK */
/*        0 on error */

int makedir(char *newdir) {
  char *buffer = strdup(newdir);
  char *p;
  int len = strlen(buffer);

  if (len <= 0) {
    free(buffer);
    return 0;
  }
  if (buffer[len - 1] == '/') {
    buffer[len - 1] = '\0';
  }
  if (mkdir(buffer, 0755) == 0) {
    free(buffer);
    return 1;
  }

  p = buffer + 1;
  while (1) {
    char hold;

    while (*p && *p != '\\' && *p != '/')
      p++;
    hold = *p;
    *p = 0;
    if ((mkdir(buffer, 0755) == -1) && (errno == ENOENT)) {
      fprintf(stderr, "Couldn't create directory %s\n", buffer);
      free(buffer);
      return 0;
    }
    if (hold == 0)
      break;
    *p++ = hold;
  }
  free(buffer);
  return 1;
}
